# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic

from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel


class DraftFieldValueContext(UniversalBaseModel):
    """
    This is a list of options that define the semantics of a field. These options will affect the generated JSON-LD context.
    """

    type: typing.Optional[str] = pydantic.Field(default=None)
    """
    This option allows to override the default field type, which is automatically calculated from the field kind.
    
    Example of a value: `http://www.w3.org/2001/XMLSchema#duration`
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
