# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic

from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel


class File(UniversalBaseModel):
    """
    A file object that can be used to read a file resource.
    """

    content_type: typing.Optional[str] = pydantic.Field(default=None)
    """
    The content type of the file.
    """

    filename: typing.Optional[str] = pydantic.Field(default=None)
    """
    The name of the file.
    """

    filesize: typing.Optional[int] = pydantic.Field(default=None)
    """
    The size of the file in bytes.
    """

    multihash: typing.Optional[str] = pydantic.Field(default=None)
    """
    The multihash of the file. [Multihash](https://www.w3.org/TR/vc-data-integrity/#multihash).
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
