# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic

from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from .presentation_id import PresentationId
from .presentation_type import PresentationType
from .uri import Uri


class Presentation(UniversalBaseModel):
    """
    A presentation of credentials. [Terminology](https://www.w3.org/TR/vc-data-model/#dfn-presentations).
    """

    type: PresentationType
    id: PresentationId
    linked_credentials: typing.List[Uri] = pydantic.Field()
    """
    A list of linked credentials.
    """

    multihash: str = pydantic.Field()
    """
    The multihash of canonical Presentation body. [Multihash](https://www.w3.org/TR/vc-data-integrity/#multihash).
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
