# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic

from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from .http_request_part import HttpRequestPart
from .uri_reference import UriReference
from .validation_error import ValidationError


class ProblemValidation(UniversalBaseModel):
    """
    A defined validation problem according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html).
    Additional information:
    type: /bad-request/validation
    status: 400
    title: Bad Request
    .
    """

    status: int = pydantic.Field()
    """
    The HTTP system code generated by the origin server for this occurrence of the problem.
    """

    title: str = pydantic.Field()
    """
    A short, human-readable summary of the problem type.
    """

    request: HttpRequestPart
    schema_: UriReference = pydantic.Field(alias="schema")
    errors: typing.List[ValidationError]
    detail: typing.Optional[str] = pydantic.Field(default=None)
    """
    A human-readable explanation specific to this occurrence of the problem.
    """

    instance: typing.Optional[str] = pydantic.Field(default=None)
    """
    A URI reference that identifies the specific occurrence of the problem. It may or may not yield further information if dereferenced.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
