# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic

from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from .didurl import Didurl
from .uri import Uri


class Service(UniversalBaseModel):
    """
    DID Document Service according to [DID Specification Registries - 5.4 Service properties](https://www.w3.org/TR/did-spec-registries/#service-properties).
    .
    """

    id: Didurl
    type: str
    service_endpoint: Uri = pydantic.Field(alias="serviceEndpoint")

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
