# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic

from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from .did import Did
from .didurl import Didurl
from .key_public_multibase import KeyPublicMultibase


class VerificationMethodMultikey(UniversalBaseModel):
    """
    VerificationMethod with type "Multikey" compatible with

    - [Data Integrity ECDSA Cryptosuites v1.0 - 2.1 Verification Methods](https://www.w3.org/TR/vc-di-ecdsa/#verification-methods)
    - [Data Integrity EdDSA Cryptosuites v1.0 - 2.1.1 Multikey](https://www.w3.org/TR/vc-di-eddsa/#verification-methods)
      .
    """

    id: Didurl
    type: str
    controller: Did
    public_key_multibase: KeyPublicMultibase = pydantic.Field(alias="publicKeyMultibase")

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
